<?xml version="1.0" encoding="UTF-8"?>

<cfsSimulation xmlns="http://www.cfs++.org/simulation">

  <documentation>
    <title>Lattice Boltzmann Topology Optimization</title>
    <authors>
      <author>Bich Ngoc Vu</author>
    </authors>
    <date>2015-08-31</date>
    <keywords>
      <keyword>SIMP</keyword>
    </keywords>
    <references>Diplomathesis Thomas Guess</references>
    <isVerified>yes</isVerified>
    <description>Lattice Boltzmann Topology Optimization based on G. Pingen, the thesis of Thomas Guess, LBM code by Markus Wittmann 
	and extension into 3D by Bich Ngoc Vu</description>    
  </documentation>
  
  <fileFormats>
    <output>
      <hdf5 /> 
      <info/>
     </output>
    <materialData file="mat.xml" format="xml"/>
  </fileFormats>
  
  <domain geometryType="3d">
    <regionList>
      <region name="design" material="99mod"/>
      <region name="boundary" material="99mod"/>
    </regionList>
  </domain>
  
  <sequenceStep>
    <analysis>
      <static/>
    </analysis>
    
    <pdeList>
      <LatticeBoltzmann>
        <regionList>
          <region name="design" boundary="false" />
          <region name="boundary" boundary="true" /> 
        </regionList>
        <bcsAndLoads>
          <inlet name="inlet" dof="x" value="0.0087719298245614"/>
          <inlet name="inlet" dof="y" value="0.0"/>
          <inlet name="inlet" dof="z" value="0.0"/>
          <outlet name="outlet"/>
        </bcsAndLoads>
        
        <LBM omega="1.9" maxWallTime="1e6"  maxIter="1000000" convergence="1e-4" solver="internal" plot="true"/>
        <storeResults>
          <elemResult type="LBMVelocity">  
            <allRegions/>  
          </elemResult>
          <elemResult type="LBMPressure">  
            <allRegions/>
          </elemResult>
          <elemResult type="mechPseudoDensity">  
            <allRegions/>  
          </elemResult>
        </storeResults> 
      </LatticeBoltzmann>
    </pdeList>

  <linearSystems>
      <system>
        <solverList>
          <pardiso/>
        </solverList>
      </system>
    </linearSystems>
  </sequenceStep>

  <optimization>
<!--     <logging designGradient="true"/> -->
    <costFunction type="pressureDrop" task="minimize" > 
      <stopping queue="999" value="0.002" type="designChange"/>
    </costFunction>
    <constraint type="volume" bound="lowerBound" value="0.3" design="density" />
    
     <optimizer type="scpip"  maxIterations="4">
      <autoscale target="1.0"/>
      <snopt>
        <option name="major_optimality_tolerance" type="real" value="1e-6"/>
        <option name="verify_level" type="integer" value="3"/>
      </snopt>
      
    </optimizer>
    
    <ersatzMaterial region="design" material="lbm" method="simp">
     <filters>
      <filter neighborhood="maxEdge" value="0.09" type="density" />
     </filters>

     <design name="density" initial="0.3" physical_lower="0" upper="1.0" />
     <transferFunction type="simp" application="lbm" design="density" param="3.0" />
      
     <export write="iteration" save="last"/>
      
    </ersatzMaterial>
    <commit mode="forward" stride="1"/>
  </optimization>  

</cfsSimulation>


